<script lang="ts">
  import { connectGanCube } from 'gan-web-bluetooth';
  import type { GanCubeConnection, GanCubeEvent } from 'gan-web-bluetooth';

  let macAddress: string | null = localStorage.getItem("mac");

  let cube: GanCubeConnection | null = null;

  let red: number = 0;
  let green: number = 0;
  let blue: number = 0;

  let canvas: HTMLCanvasElement;
  let canvasWidth: number = 1000;
  let canvasHeight: number = 1000;

  let x = Math.floor(canvasWidth / 2);
  let y = Math.floor(canvasWidth / 2);

  const getMACAddress = async () => {
    // check localstorage
    let stored: null | string = localStorage.getItem("mac");
    if (stored) return stored;

    // if not stored, ask for it
    macAddress = prompt("Input the MAC address of your GAN cube.");

    // save the new thing, and return
    if (typeof macAddress == "string") localStorage.setItem("mac", macAddress);
    return macAddress;
  }

  const drawXY = () => {
    const w = 20;
    const ctx = canvas.getContext("2d");
    if (ctx == null) {
      console.error("Could not get context from canvas element.");
      return;
    }
    ctx.fillStyle = `rgb(${red}, ${green}, ${blue})`;
    ctx.fillRect(x - w, y - w,
                 w,w);
  };

  const cubeEventHandler = (event: GanCubeEvent) => {
    if (event.type == "FACELETS") {
      console.log("Cube facelets state", event.facelets);
    } else if (event.type == "MOVE") {
      console.log("Cube move", event.move);

      // colors
      const colorStep = 10;
      const colorMax: number = 255;
      const clamp = (c: number) => Math.max(0, Math.min(c, colorMax));
      const more = (c: number) => clamp(c + colorStep);
      const less = (c: number) => clamp(c - colorStep);
      if (event.move == "F") {
        green = more(green);
      } else if (event.move == "F'") {
        green = less(green);
      } else if (event.move == "R") {
        red = more(red);
      } else if (event.move == "R'") {
        red = less(red);
      } else if (event.move == "B") {
        blue = more(blue);
      } else if (event.move == "B'") {
        blue = less(blue);
      }

      // y-axis move, orange side
      const moveStep = 10;
      if (event.move == "L") {
        y = y + moveStep;
      } else if (event.move == "L'") {
        y = y - moveStep;

      // x-axis move, white side
      } else if (event.move == "U") {
        x = x - moveStep;
      } else if (event.move == "U'") {
        x = x + moveStep;

      } else if (event.move == "D") {
      } else if (event.move == "D'") { }
      drawXY();
    }
  }

  async function connectCube() {
    // do the dance
    cube = await connectGanCube(getMACAddress);
    console.log(`connected? ${cube}`);

    cube.events$.subscribe(cubeEventHandler);

    await cube.sendCubeCommand({ type: "REQUEST_FACELETS" });
  }

  const deleteMac = () => {
    localStorage.removeItem("mac");
    macAddress = null;
  }

</script>

<main>
  {#if cube}
    <canvas bind:this={canvas} width={canvasWidth} height={canvasHeight} />
  {:else}
    <button on:click={connectCube}>Connect</button>
    {#if macAddress}
      <h5>MAC address: {macAddress}</h5>
      <button on:click={deleteMac}>Delete Mac address</button>
    {:else}
      <h5>No MAC address stored</h5>
    {/if}
  {/if}
</main>
